| OpenCV 3.4.7 Open Source Computer Vision

Modules | Enumerations | Functions
Image file reading and writing

## Modules
| C API
| iOS glue

## Enumerations
enum | cv::ImreadModes { cv::IMREAD_UNCHANGED = -1, cv::IMREAD_GRAYSCALE = 0, cv::IMREAD_COLOR = 1, cv::IMREAD_ANYDEPTH = 2, cv::IMREAD_ANYCOLOR = 4, cv::IMREAD_LOAD_GDAL = 8, cv::IMREAD_REDUCED_GRAYSCALE_2 = 16, cv::IMREAD_REDUCED_COLOR_2 = 17, cv::IMREAD_REDUCED_GRAYSCALE_4 = 32, cv::IMREAD_REDUCED_COLOR_4 = 33, cv::IMREAD_REDUCED_GRAYSCALE_8 = 64, cv::IMREAD_REDUCED_COLOR_8 = 65, cv::IMREAD_IGNORE_ORIENTATION = 128 }
| Imread flags. More...
enum | cv::ImwriteEXRTypeFlags { cv::IMWRITE_EXR_TYPE_HALF = 1, cv::IMWRITE_EXR_TYPE_FLOAT = 2 }
enum | cv::ImwriteFlags { cv::IMWRITE_JPEG_QUALITY = 1, cv::IMWRITE_JPEG_PROGRESSIVE = 2, cv::IMWRITE_JPEG_OPTIMIZE = 3, cv::IMWRITE_JPEG_RST_INTERVAL = 4, cv::IMWRITE_JPEG_LUMA_QUALITY = 5, cv::IMWRITE_JPEG_CHROMA_QUALITY = 6, cv::IMWRITE_PNG_COMPRESSION = 16, cv::IMWRITE_PNG_STRATEGY = 17, cv::IMWRITE_PNG_BILEVEL = 18, cv::IMWRITE_PXM_BINARY = 32, cv::IMWRITE_EXR_TYPE = (3 << 4) + 0, cv::IMWRITE_WEBP_QUALITY = 64, cv::IMWRITE_PAM_TUPLETYPE = 128, cv::IMWRITE_TIFF_RESUNIT = 256, cv::IMWRITE_TIFF_XDPI = 257, cv::IMWRITE_TIFF_YDPI = 258, cv::IMWRITE_TIFF_COMPRESSION = 259 }
| Imwrite flags. More...
enum | cv::ImwritePAMFlags { cv::IMWRITE_PAM_FORMAT_NULL = 0, cv::IMWRITE_PAM_FORMAT_BLACKANDWHITE = 1, cv::IMWRITE_PAM_FORMAT_GRAYSCALE = 2, cv::IMWRITE_PAM_FORMAT_GRAYSCALE_ALPHA = 3, cv::IMWRITE_PAM_FORMAT_RGB = 4, cv::IMWRITE_PAM_FORMAT_RGB_ALPHA = 5 }
| Imwrite PAM specific tupletype flags used to define the 'TUPETYPE' field of a PAM file. More...
enum | cv::ImwritePNGFlags { cv::IMWRITE_PNG_STRATEGY_DEFAULT = 0, cv::IMWRITE_PNG_STRATEGY_FILTERED = 1, cv::IMWRITE_PNG_STRATEGY_HUFFMAN_ONLY = 2, cv::IMWRITE_PNG_STRATEGY_RLE = 3, cv::IMWRITE_PNG_STRATEGY_FIXED = 4 }
| Imwrite PNG specific flags used to tune the compression algorithm. More...

## Functions
Mat | cv::imdecode (InputArray buf, int flags)
| Reads an image from a buffer in memory. More...
Mat | cv::imdecode (InputArray buf, int flags, Mat *dst)
bool | cv::imencode (const String &ext, InputArray img, std::vector< uchar > &buf, const std::vector< int > &params=std::vector< int >())
| Encodes an image into a memory buffer. More...
Mat | cv::imread (const String &filename, int flags=IMREAD_COLOR)
| Loads an image from a file. More...
bool | cv::imreadmulti (const String &filename, std::vector< Mat > &mats, int flags=IMREAD_ANYCOLOR)
| Loads a multi-page image from a file. More...
bool | cv::imwrite (const String &filename, InputArray img, const std::vector< int > &params=std::vector< int >())
| Saves an image to a specified file. More...

## Detailed Description

## Enumeration Type Documentation

## § ImreadModes

enum cv::ImreadModes

`#include <opencv2/imgcodecs.hpp>`

Imread flags.

Enumerator
IMREAD_UNCHANGED Python: cv.IMREAD_UNCHANGED | If set, return the loaded image as is (with alpha channel, otherwise it gets cropped).
IMREAD_GRAYSCALE Python: cv.IMREAD_GRAYSCALE | If set, always convert image to the single channel grayscale image (codec internal conversion).
IMREAD_COLOR Python: cv.IMREAD_COLOR | If set, always convert image to the 3 channel BGR color image.
IMREAD_ANYDEPTH Python: cv.IMREAD_ANYDEPTH | If set, return 16-bit/32-bit image when the input has the corresponding depth, otherwise convert it to 8-bit.
IMREAD_ANYCOLOR Python: cv.IMREAD_ANYCOLOR | If set, the image is read in any possible color format.
IMREAD_LOAD_GDAL Python: cv.IMREAD_LOAD_GDAL | If set, use the gdal driver for loading the image.
IMREAD_REDUCED_GRAYSCALE_2 Python: cv.IMREAD_REDUCED_GRAYSCALE_2 | If set, always convert image to the single channel grayscale image and the image size reduced 1/2.
IMREAD_REDUCED_COLOR_2 Python: cv.IMREAD_REDUCED_COLOR_2 | If set, always convert image to the 3 channel BGR color image and the image size reduced 1/2.
IMREAD_REDUCED_GRAYSCALE_4 Python: cv.IMREAD_REDUCED_GRAYSCALE_4 | If set, always convert image to the single channel grayscale image and the image size reduced 1/4.
IMREAD_REDUCED_COLOR_4 Python: cv.IMREAD_REDUCED_COLOR_4 | If set, always convert image to the 3 channel BGR color image and the image size reduced 1/4.
IMREAD_REDUCED_GRAYSCALE_8 Python: cv.IMREAD_REDUCED_GRAYSCALE_8 | If set, always convert image to the single channel grayscale image and the image size reduced 1/8.
IMREAD_REDUCED_COLOR_8 Python: cv.IMREAD_REDUCED_COLOR_8 | If set, always convert image to the 3 channel BGR color image and the image size reduced 1/8.
IMREAD_IGNORE_ORIENTATION Python: cv.IMREAD_IGNORE_ORIENTATION | If set, do not rotate the image according to EXIF's orientation flag.

## § ImwriteEXRTypeFlags

enum cv::ImwriteEXRTypeFlags

`#include <opencv2/imgcodecs.hpp>`

Enumerator
IMWRITE_EXR_TYPE_HALF Python: cv.IMWRITE_EXR_TYPE_HALF | store as HALF (FP16)
IMWRITE_EXR_TYPE_FLOAT Python: cv.IMWRITE_EXR_TYPE_FLOAT | store as FP32 (default)

## § ImwriteFlags

enum cv::ImwriteFlags

`#include <opencv2/imgcodecs.hpp>`

Imwrite flags.

Enumerator
IMWRITE_JPEG_QUALITY Python: cv.IMWRITE_JPEG_QUALITY | For JPEG, it can be a quality from 0 to 100 (the higher is the better). Default value is 95.
IMWRITE_JPEG_PROGRESSIVE Python: cv.IMWRITE_JPEG_PROGRESSIVE | Enable JPEG features, 0 or 1, default is False.
IMWRITE_JPEG_OPTIMIZE Python: cv.IMWRITE_JPEG_OPTIMIZE | Enable JPEG features, 0 or 1, default is False.
IMWRITE_JPEG_RST_INTERVAL Python: cv.IMWRITE_JPEG_RST_INTERVAL | JPEG restart interval, 0 - 65535, default is 0 - no restart.
IMWRITE_JPEG_LUMA_QUALITY Python: cv.IMWRITE_JPEG_LUMA_QUALITY | Separate luma quality level, 0 - 100, default is 0 - don't use.
IMWRITE_JPEG_CHROMA_QUALITY Python: cv.IMWRITE_JPEG_CHROMA_QUALITY | Separate chroma quality level, 0 - 100, default is 0 - don't use.
IMWRITE_PNG_COMPRESSION Python: cv.IMWRITE_PNG_COMPRESSION | For PNG, it can be the compression level from 0 to 9. A higher value means a smaller size and longer compression time. If specified, strategy is changed to IMWRITE_PNG_STRATEGY_DEFAULT (Z_DEFAULT_STRATEGY). Default value is 1 (best speed setting).
IMWRITE_PNG_STRATEGY Python: cv.IMWRITE_PNG_STRATEGY | One of cv::ImwritePNGFlags, default is IMWRITE_PNG_STRATEGY_RLE.
IMWRITE_PNG_BILEVEL Python: cv.IMWRITE_PNG_BILEVEL | Binary level PNG, 0 or 1, default is 0.
IMWRITE_PXM_BINARY Python: cv.IMWRITE_PXM_BINARY | For PPM, PGM, or PBM, it can be a binary format flag, 0 or 1. Default value is 1.
IMWRITE_EXR_TYPE Python: cv.IMWRITE_EXR_TYPE |
IMWRITE_WEBP_QUALITY Python: cv.IMWRITE_WEBP_QUALITY | override EXR storage type (FLOAT (FP32) is default) For WEBP, it can be a quality from 1 to 100 (the higher is the better). By default (without any parameter) and for quality above 100 the lossless compression is used.
IMWRITE_PAM_TUPLETYPE Python: cv.IMWRITE_PAM_TUPLETYPE | For PAM, sets the TUPLETYPE field to the corresponding string value that is defined for the format.
IMWRITE_TIFF_RESUNIT Python: cv.IMWRITE_TIFF_RESUNIT | For TIFF, use to specify which DPI resolution unit to set; see libtiff documentation for valid values.
IMWRITE_TIFF_XDPI Python: cv.IMWRITE_TIFF_XDPI | For TIFF, use to specify the X direction DPI.
IMWRITE_TIFF_YDPI Python: cv.IMWRITE_TIFF_YDPI | For TIFF, use to specify the Y direction DPI.
IMWRITE_TIFF_COMPRESSION Python: cv.IMWRITE_TIFF_COMPRESSION | For TIFF, use to specify the image compression scheme. See libtiff for integer constants corresponding to compression formats. Note, for images whose depth is CV_32F, only libtiff's SGILOG compression scheme is used. For other supported depths, the compression scheme can be specified by this flag; LZW compression is the default.

## § ImwritePAMFlags

enum cv::ImwritePAMFlags

`#include <opencv2/imgcodecs.hpp>`

Imwrite PAM specific tupletype flags used to define the 'TUPETYPE' field of a PAM file.

Enumerator
IMWRITE_PAM_FORMAT_NULL Python: cv.IMWRITE_PAM_FORMAT_NULL |
IMWRITE_PAM_FORMAT_BLACKANDWHITE Python: cv.IMWRITE_PAM_FORMAT_BLACKANDWHITE |
IMWRITE_PAM_FORMAT_GRAYSCALE Python: cv.IMWRITE_PAM_FORMAT_GRAYSCALE |
IMWRITE_PAM_FORMAT_GRAYSCALE_ALPHA Python: cv.IMWRITE_PAM_FORMAT_GRAYSCALE_ALPHA |
IMWRITE_PAM_FORMAT_RGB Python: cv.IMWRITE_PAM_FORMAT_RGB |
IMWRITE_PAM_FORMAT_RGB_ALPHA Python: cv.IMWRITE_PAM_FORMAT_RGB_ALPHA |

## § ImwritePNGFlags

enum cv::ImwritePNGFlags

`#include <opencv2/imgcodecs.hpp>`

Imwrite PNG specific flags used to tune the compression algorithm.

These flags will be modify the way of PNG image compression and will be passed to the underlying zlib processing stage.

- The effect of IMWRITE_PNG_STRATEGY_FILTERED is to force more Huffman coding and less string matching; it is somewhat intermediate between IMWRITE_PNG_STRATEGY_DEFAULT and IMWRITE_PNG_STRATEGY_HUFFMAN_ONLY.
- IMWRITE_PNG_STRATEGY_RLE is designed to be almost as fast as IMWRITE_PNG_STRATEGY_HUFFMAN_ONLY, but give better compression for PNG image data.
- The strategy parameter only affects the compression ratio but not the correctness of the compressed output even if it is not set appropriately.
- IMWRITE_PNG_STRATEGY_FIXED prevents the use of dynamic Huffman codes, allowing for a simpler decoder for special applications.

Enumerator
IMWRITE_PNG_STRATEGY_DEFAULT Python: cv.IMWRITE_PNG_STRATEGY_DEFAULT | Use this value for normal data.
IMWRITE_PNG_STRATEGY_FILTERED Python: cv.IMWRITE_PNG_STRATEGY_FILTERED | Use this value for data produced by a filter (or predictor).Filtered data consists mostly of small values with a somewhat random distribution. In this case, the compression algorithm is tuned to compress them better.
IMWRITE_PNG_STRATEGY_HUFFMAN_ONLY Python: cv.IMWRITE_PNG_STRATEGY_HUFFMAN_ONLY | Use this value to force Huffman encoding only (no string match).
IMWRITE_PNG_STRATEGY_RLE Python: cv.IMWRITE_PNG_STRATEGY_RLE | Use this value to limit match distances to one (run-length encoding).
IMWRITE_PNG_STRATEGY_FIXED Python: cv.IMWRITE_PNG_STRATEGY_FIXED | Using this value prevents the use of dynamic Huffman codes, allowing for a simpler decoder for special applications.

## Function Documentation

## § imdecode() [1/2]

Mat cv::imdecode | ( | InputArray | buf,
|  | int | flags
| ) |  |

Python:
| retval | = | cv.imdecode( | buf, flags | )

`#include <opencv2/imgcodecs.hpp>`

Reads an image from a buffer in memory.

The function imdecode reads an image from the specified buffer in the memory. If the buffer is too short or contains invalid data, the function returns an empty matrix ( Mat::data==NULL ).

See cv::imread for the list of supported formats and flags description.

Note
  In the case of color images, the decoded images will have the channels stored in B G R order.

Parameters

  buf | Input array or vector of bytes.
  flags | The same flags as in cv::imread, see cv::ImreadModes.

## § imdecode() [2/2]

Mat cv::imdecode | ( | InputArray | buf,
|  | int | flags,
|  | Mat * | dst
| ) |  |

Python:
| retval | = | cv.imdecode( | buf, flags | )

`#include <opencv2/imgcodecs.hpp>`

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Parameters

  buf |
  flags |
  dst | The optional output placeholder for the decoded matrix. It can save the image reallocations when the function is called repeatedly for images of the same size.

## § imencode()

bool cv::imencode | ( | const String & | ext,
|  | InputArray | img,
|  | std::vector< uchar > & | buf,
|  | const std::vector< int > & | params = `std::vector< int >()`
| ) |  |

Python:
| retval, buf | = | cv.imencode( | ext, img[, params] | )

`#include <opencv2/imgcodecs.hpp>`

Encodes an image into a memory buffer.

The function imencode compresses the image and stores it in the memory buffer that is resized to fit the result. See cv::imwrite for the list of supported formats and flags description.

Parameters

  ext | File extension that defines the output format.
  img | Image to be written.
  buf | Output buffer resized to fit the compressed image.
  params | Format-specific parameters. See cv::imwrite and cv::ImwriteFlags.

## § imread()

Mat cv::imread | ( | const String & | filename,
|  | int | flags = `IMREAD_COLOR`
| ) |  |

Python:
| retval | = | cv.imread( | filename[, flags] | )

`#include <opencv2/imgcodecs.hpp>`

Loads an image from a file.

The function imread loads an image from the specified file and returns it. If the image cannot be read (because of missing file, improper permissions, unsupported or invalid format), the function returns an empty matrix ( Mat::data==NULL ).

Currently, the following file formats are supported:

- Windows bitmaps - *.bmp, *.dib (always supported)
- JPEG files - *.jpeg, *.jpg, *.jpe (see the Note section)
- JPEG 2000 files - *.jp2 (see the Note section)
- Portable Network Graphics - *.png (see the Note section)
- WebP - *.webp (see the Note section)
- Portable image format - *.pbm, *.pgm, *.ppm *.pxm, *.pnm (always supported)
- Sun rasters - *.sr, *.ras (always supported)
- TIFF files - *.tiff, *.tif (see the Note section)
- OpenEXR Image files - *.exr (see the Note section)
- Radiance HDR - *.hdr, *.pic (always supported)
- Raster and Vector geospatial data supported by GDAL (see the Note section)

Note
  - The function determines the type of an image by the content, not by the file extension.
  - In the case of color images, the decoded images will have the channels stored in B G R order.
  - When using IMREAD_GRAYSCALE, the codec's internal grayscale conversion will be used, if available. Results may differ to the output of cvtColor()
  - On Microsoft Windows* OS and MacOSX*, the codecs shipped with an OpenCV image (libjpeg, libpng, libtiff, and libjasper) are used by default. So, OpenCV can always read JPEGs, PNGs, and TIFFs. On MacOSX, there is also an option to use native MacOSX image readers. But beware that currently these native image loaders give images with different pixel values because of the color management embedded into MacOSX.
  - On Linux*, BSD flavors and other Unix-like open-source operating systems, OpenCV looks for codecs supplied with an OS image. Install the relevant packages (do not forget the development files, for example, "libjpeg-dev", in Debian* and Ubuntu*) to get the codec support or turn on the OPENCV_BUILD_3RDPARTY_LIBS flag in CMake.
  - In the case you set WITH_GDAL flag to true in CMake and IMREAD_LOAD_GDAL to load the image, then the GDAL driver will be used in order to decode the image, supporting the following formats: Raster, Vector.
  - If EXIF information are embedded in the image file, the EXIF orientation will be taken into account and thus the image will be rotated accordingly except if the flag IMREAD_IGNORE_ORIENTATION is passed.
  - By default number of pixels must be less than 2^30. Limit can be set using system variable OPENCV_IO_MAX_IMAGE_PIXELS

Parameters

  filename | Name of file to be loaded.
  flags | Flag that can take values of cv::ImreadModes

Examples:
  fld_lines.cpp, samples/cpp/connected_components.cpp, samples/cpp/create_mask.cpp, samples/cpp/demhist.cpp, samples/cpp/distrans.cpp, samples/cpp/edge.cpp, samples/cpp/facedetect.cpp, samples/cpp/falsecolor.cpp, samples/cpp/ffilldemo.cpp, samples/cpp/fitellipse.cpp, samples/cpp/grabcut.cpp, samples/cpp/image_alignment.cpp, samples/cpp/pca.cpp, samples/cpp/shape_example.cpp, samples/cpp/squares.cpp, samples/cpp/stitching.cpp, samples/cpp/stitching_detailed.cpp, samples/cpp/train_HOG.cpp, samples/cpp/tutorial_code/features2D/Homography/decompose_homography.cpp, samples/cpp/tutorial_code/features2D/Homography/homography_from_camera_displacement.cpp, samples/cpp/tutorial_code/features2D/Homography/pose_from_homography.cpp, samples/cpp/tutorial_code/HighGUI/AddingImagesTrackbar.cpp, samples/cpp/tutorial_code/Histograms_Matching/MatchTemplate_Demo.cpp, samples/cpp/tutorial_code/ImgProc/Morphology_1.cpp, samples/cpp/tutorial_code/ImgProc/Morphology_2.cpp, samples/cpp/tutorial_code/ImgProc/Pyramids/Pyramids.cpp, samples/cpp/tutorial_code/ImgProc/Smoothing/Smoothing.cpp, samples/cpp/tutorial_code/ImgTrans/copyMakeBorder_demo.cpp, samples/cpp/tutorial_code/ImgTrans/houghcircles.cpp, samples/cpp/tutorial_code/ImgTrans/houghlines.cpp, samples/cpp/tutorial_code/ImgTrans/Sobel_Demo.cpp, samples/cpp/tutorial_code/ml/introduction_to_pca/introduction_to_pca.cpp, samples/cpp/tutorial_code/photo/non_photorealistic_rendering/npr_demo.cpp, samples/cpp/tutorial_code/photo/seamless_cloning/cloning_demo.cpp, samples/cpp/warpPerspective_demo.cpp, samples/cpp/watershed.cpp, samples/dnn/colorization.cpp, samples/dnn/openpose.cpp, samples/tapi/hog.cpp, and samples/tapi/squares.cpp.

## § imreadmulti()

bool cv::imreadmulti | ( | const String & | filename,
|  | std::vector< Mat > & | mats,
|  | int | flags = `IMREAD_ANYCOLOR`
| ) |  |

Python:
| retval, mats | = | cv.imreadmulti( | filename[, mats[, flags]] | )

`#include <opencv2/imgcodecs.hpp>`

Loads a multi-page image from a file.

The function imreadmulti loads a multi-page image from the specified file into a vector of Mat objects.

Parameters

  filename | Name of file to be loaded.
  flags | Flag that can take values of cv::ImreadModes, default with cv::IMREAD_ANYCOLOR.
  mats | A vector of Mat objects holding each page, if more than one.

See also
  cv::imread

## § imwrite()

bool cv::imwrite | ( | const String & | filename,
|  | InputArray | img,
|  | const std::vector< int > & | params = `std::vector< int >()`
| ) |  |

Python:
| retval | = | cv.imwrite( | filename, img[, params] | )

`#include <opencv2/imgcodecs.hpp>`

Saves an image to a specified file.

The function imwrite saves the image to the specified file. The image format is chosen based on the filename extension (see cv::imread for the list of extensions). In general, only 8-bit single-channel or 3-channel (with 'BGR' channel order) images can be saved using this function, with these exceptions:

- 16-bit unsigned (CV_16U) images can be saved in the case of PNG, JPEG 2000, and TIFF formats
- 32-bit float (CV_32F) images can be saved in TIFF, OpenEXR, and Radiance HDR formats; 3-channel (CV_32FC3) TIFF images will be saved using the LogLuv high dynamic range encoding (4 bytes per pixel)
- PNG images with an alpha channel can be saved using this function. To do this, create 8-bit (or 16-bit) 4-channel image BGRA, where the alpha channel goes last. Fully transparent pixels should have alpha set to 0, fully opaque pixels should have alpha set to 255/65535 (see the code sample below).

If the format, depth or channel order is different, use Mat::convertTo and cv::cvtColor to convert it before saving. Or, use the universal FileStorage I/O functions to save the image to XML or YAML format.

The sample below shows how to create a BGRA image and save it to a PNG file. It also demonstrates how to set custom compression parameters:

#include <opencv2/imgcodecs.hpp>
using namespace cv;
using namespace std;
static void createAlphaMat(Mat &mat)
{
CV_Assert(mat.channels() == 4);
for (int i = 0; i < mat.rows; ++i)
{
for (int j = 0; j < mat.cols; ++j)
{
Vec4b& bgra = mat.at<Vec4b>(i, j);
bgra[0] = UCHAR_MAX; // Blue
bgra[1] = saturate_cast<uchar>((float (mat.cols - j)) / ((float)mat.cols) * UCHAR_MAX); // Green
bgra[2] = saturate_cast<uchar>((float (mat.rows - i)) / ((float)mat.rows) * UCHAR_MAX); // Red
bgra[3] = saturate_cast<uchar>(0.5 * (bgra[1] + bgra[2])); // Alpha
}
}
}
int main()
{
// Create mat with alpha channel
Mat mat(480, 640, CV_8UC4);
createAlphaMat(mat);
vector<int> compression_params;
compression_params.push_back(IMWRITE_PNG_COMPRESSION);
compression_params.push_back(9);
bool result = false;
try
{
result = imwrite("alpha.png", mat, compression_params);
}
catch (const cv::Exception& ex)
{
fprintf(stderr, "Exception converting image to PNG format: %s\n", ex.what());
}
if (result)
printf("Saved PNG file with alpha data.\n");
else
printf("ERROR: Can't save PNG file.\n");
return result ? 0 : 1;
}

Parameters

  filename | Name of the file.
  img | Image to be saved.
  params | Format-specific parameters encoded as pairs (paramId_1, paramValue_1, paramId_2, paramValue_2, ... .) see cv::ImwriteFlags

Examples:
  samples/cpp/image_alignment.cpp, samples/cpp/stitching.cpp, samples/cpp/stitching_detailed.cpp, samples/cpp/tutorial_code/photo/seamless_cloning/cloning_demo.cpp, samples/tapi/hog.cpp, and samples/tapi/squares.cpp.